#!/usr/bin/env python3
#
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
#
# Weitere Lizenz: GPL V3.0
# Siehe http://www.gnu.org/licenses/gpl-3.0.html
#
# $Id: queue.py 679 2014-06-24 13:57:18Z pieper $

class Queue (object): 
	"""
	Die Klasse Queue
	Objekte der Klasse Queue (Warteschlange) verwalten beliebige Objekte nach 
	dem FirstIn-First-Out-Prinzip, d.h., das zuerst abgelegte Objekt wird als 
	erstes wieder entnommen. 
	"""

	def __init__(self):
		"""Eine leere Schlange wird erzeugt."""
		self._queue= list()


	def isEmpty(self):
		"""Die Anfrage liefert den Wert true, wenn die Schlange keine Objekte
		enthält, sonst liefert sie den Wert false."""
		return self._queue.__len__() == 0


	def enqueue(self, pObject= None):
		"""Das Objekt pObject wird an die Schlange angehängt. Falls pObject 
		gleich null ist, bleibt die Schlange unverändert.
		"""
		if pObject == None: 
			return
		else:
			self._queue.append(pObject)


	def dequeue(self):
		"""Das erste Objekt wird aus der Schlange entfernt. Falls die Schlange
		leer ist, wird sie nicht verändert."""
		erstes= self._queue[0]
		self._queue.remove(self._queue[0])
		
		
	def front(self):
		"""Die Anfrage liefert das erste Objekt der Schlange. Die Schlange 
		bleibt unverändert. 
		Falls die Schlange leer ist, wird null zurück gegeben."""
		if self.isEmpty():
			return None
		else:
			return 	self._queue[0]

	def __str__(self):	
		sys.stdout = x = ListStream()
		for elem in self._queue:
			print(str(elem),end="")
		sys.stdout = sys.__stdout__
		return str(x.data)
			

import sys
class ListStream:
    def __init__(self):
        self.data = ""
    def write(self, s):
        self.data+=s


if __name__ == "__main__":
	ueberschrift="Selbsttest der Klasse Queue\n"
	print (ueberschrift+(ueberschrift.__len__()-1)*"*")
	
	meinSchlang= Queue()
	meinSchlang.enqueue("Ich")
	meinSchlang.enqueue("Du")
	meinSchlang.enqueue("Er")
	meinSchlang.enqueue("Sie")
	meinSchlang.enqueue("Wir")
	meinSchlang.enqueue("Ihr")
	meinSchlang.enqueue("Sie")
	
	print (meinSchlang)    
	print ("meinSchlang.front()",meinSchlang.front())
	
	print ("meinSchlang.dequeue()")
	meinSchlang.dequeue()
	print (meinSchlang)    
	
	meinSchlang.dequeue()
	print (meinSchlang)    
	meinSchlang.dequeue()
	print (meinSchlang)    
	meinSchlang.dequeue()
	print (meinSchlang)    
	meinSchlang.enqueue(" - mal sehen - ")
	meinSchlang.dequeue()
	print (meinSchlang)    
	meinSchlang.dequeue()
	print (meinSchlang)    
	meinSchlang.dequeue()
	print (meinSchlang)    
